Search results

Find and Replace in JavaScript (ES5) DocumentEditor control

17 Mar 2023 / 6 minutes to read

The Document Editor component searches a portion of text in the document through a built-in interface called OptionsPane or rich APIs. When used in combination with selection performs various operations on the search results like replacing it with some other text, highlighting it, making it bolder, and more.

Options pane

This provides the options to search for a portion of text in the document. After search operation is completed, the search results will be displayed in a list and options to navigate between them. The current occurrence of matched text or all occurrences with another text can be replaced by switching to Replace tab. This pane is opened using the keyboard shortcut CTRL+F. You can also open it programmatically using the following sample code.

Source
Preview
index.js
index.html
Copied to clipboard
var documenteditor = new ej.documenteditor.DocumentEditor({ enableSelection: true, enableSearch: true, enableEditor: true, isReadOnly: false, enableOptionsPane: true });
documenteditor.appendTo('#DocumentEditor');
var sfdt = `{
    "sections": [
        {
            "blocks": [
                {
                    "inlines": [
                        {
                            "characterFormat": {
                                "bold": true,
                                "italic": true
                            },
                            "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                        }
                    ]
                }
            ]
        }
    ]
}`;
documenteditor.open(sfdt);
document.getElementById('showhidepane').addEventListener('click', () => {
    documenteditor.showOptionsPane();
});
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-documenteditor/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-buttons/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-base/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-dropdowns/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-inputs/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-lists/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-navigations/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-popups/styles/fabric.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-splitbuttons/styles/fabric.css" rel="stylesheet"> 
    
    
<script src="https://cdn.syncfusion.com/ej2/20.4.48/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div style="display: inline">
            <button id="showhidepane" class="e-control e-btn e-primary">Optionspane</button>
        </div>
        <div style="width:100%;height: 100%">
            <!--Element which will render as DocumentEditor -->
            <div id="DocumentEditor"></div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

You can close the options pane by pressing Esc key.

The Search module of Document Editor exposes the following APIs:

API Name Type Description
findAll() Method Searches for specified text in the whole document and highlights it with yellow.
searchResults Property This is an instance of SearchResults.
find() Method Find immediate occurrence of specified text from cursor position in the document and highlights it with yellow.

Find the immediate occurrence in the document

Using find() method, you can find the immediate occurrence of specified text from current cursor position in the document.

The following example code illustrates how to use find in Document editor.

Copied to clipboard
documenteditor.search.find('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Find all the occurrences in the document

Using findAll() method, you can find all the occurrences of specified text in the whole document and highlight it with yellow.

The following example code illustrates how to find All the text in the document.

Copied to clipboard
documenteditor.search.findAll('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Search results

The SearchResults class provides information about the search results after a search operation is completed that can be identified using the searchResultsChange event. This will expose the following APIs:

API Name Type Description
length Property Returns the total number of results found on the search.
index Property Returns the index of selected search result. You can change the value for this property to move the selection.
replaceAll() Method Replaces all the occurrences with specified text.
clear() Method Clears the search result.

Replace all the occurrences

Using replaceAll, you can replace all the occurrences with specified text.

The following example code illustrates how to use replace All in Document editor.

Copied to clipboard
documentEditor.search.findAll('Some text');
// Replace all the searched text with word 'Mike'
documentEditor.search.searchResults.replaceAll("Mike");  

Replace

Using insertText, you can replace the current searched text with specified text and it replace single occurrence.

Note: This insertText API accepts following control characters

  • New line characters (“\r”, “\r\n”, “\n”) - Inserts a new paragraph and appends the remaining text to the new paragraph.
  • Line break character (“\v”) - Moves the remaining text to start in new line.
  • Tab character (“\t”) - Allocates a tab space and continue the next character.

The following example code illustrates how to find a text in the document and replace each occurrence of the text one by one programmatically.

Copied to clipboard
container.documentEditor.search.findAll('works');

let searchLength: number = container.documentEditor.search.searchResults.length;

for (let i = 0; i < searchLength; i++) {
    // It will move selection to specific searched index,move to each occurrence one by one
    container.documentEditor.search.searchResults.index = i;
    // Replace it with some text
    container.documentEditor.editor.insertText('Hello');
}

container.documentEditor.search.searchResults.clear();

SearchResultsChange event

DocumentEditor exposes the searchResultsChange event that will be triggered whenever search results are changed. Consider the following scenarios:

  • A search operation is completed with some results.
  • The results are replaced with some other text, since it will be cleared automatically.
  • The results are cleared explicitly.

Refer to the following code example.

Copied to clipboard
documenteditor.searchResultsChange = function() {

};

Customize find and replace

Using the exposed APIs, you can customize the find and replace functionality in your application. Refer to the following sample code.

Source
Preview
index.js
index.html
Copied to clipboard
var documenteditor = new ej.documenteditor.DocumentEditor({ enableSelection: true, enableSearch: true, enableEditor: true, isReadOnly: false });
documenteditor.appendTo('#DocumentEditor');
var sfdt = `{
    "sections": [
        {
            "blocks": [
                {
                    "inlines": [
                        {
                            "characterFormat": {
                                "bold": true,
                                "italic": true
                            },
                            "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                        }
                    ]
                }
            ]
        }
    ]
}`;
documenteditor.open(sfdt);
document.getElementById('replace_all').addEventListener('click',function () {
    var textToFind = (document.getElementById('find_text')).value;
    var textToReplace = (document.getElementById('replace_text')).value;
    if (textToFind !== '') {
        // Find all the occurences of given text
        documenteditor.searchModule.findAll(textToFind);
        if (documenteditor.searchModule.searchResults.length > 0) {
            // Replace all the occurences of given text
            documenteditor.searchModule.searchResults.replaceAll(textToReplace);
        }
    }
});
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-documenteditor/styles/fabric.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/20.4.48/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div>
            <table>
                <tbody><tr>
                    <td>
                        <label>Text to find:</label>
                    </td>
                    <td>
                        <input type="text" id="find_text">
                    </td>
                </tr>
                <tr>
                    <td>
                        <label>Text to replace:</label>
                    </td>
                    <td>
                        <input type="text" id="replace_text">
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <button id="replace_all" v-on:click="onReplaceButtonClick" style="float:right;margin-top: 10px;" class="e-control e-btn">Replace All</button>
                    </td>
                </tr>
            </tbody></table>
        </div>

        <div style="width:100%;height: 100%">
            <!--Element which will render as DocumentEditor -->
            <div id="DocumentEditor"></div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Find and replace in Vue Document editor component

30 Dec 202424 minutes to read

The Document Editor component searches a portion of text in the document through a built-in interface called OptionsPane or rich APIs. When used in combination with selection performs various operations on the search results like replacing it with some other text, highlighting it, making it bolder, and more.

Options pane

This provides the options to search for a portion of text in the document. After search operation is completed, the search results will be displayed in a list and options to navigate between them. The current occurrence of matched text or all occurrences with another text can be replaced by switching to Replace tab. This pane is opened using the keyboard shortcut CTRL+F. You can also open it programmatically using the following sample code.

<template>
  <div id="app" height="350px">
    <div>
      <button v-on:click='showOptionsPane'>Save</button>
    </div>
    <ejs-documenteditor ref="documenteditor" :enableEditor='true' :enableSearch='true' :enableOptionsPane='true'
      :isReadOnly='false' height="370px" style="width: 100%;"></ejs-documenteditor>
  </div>
</template>
<script setup>
import { DocumentEditorComponent as EjsDocumenteditor, Selection, Editor, Search, OptionsPane } from '@syncfusion/ej2-vue-documenteditor';
import { onMounted, provide, ref } from 'vue';

const documenteditor = ref(null);
provide('DocumentEditor', [Selection, Editor, Search, OptionsPane]);

const showOptionsPane = function () {
  //Open options pane.
  documenteditor.value.showOptionsPane();
}

onMounted(function () {
  let sfdt = `{
              "sections": [
                  {
                      "blocks": [
                          {
                              "inlines": [
                                  {
                                      "characterFormat": {
                                          "bold": true,
                                          "italic": true
                                      },
                                      "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                  }
                              ]
                          }
                      ]
                  }
              ]
          }`;
  documenteditor.value.open(sfdt);
})
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>
<template>
  <div id="app" height="350px">
    <div>
      <button v-on:click='showOptionsPane'>Save</button>
    </div>
    <ejs-documenteditor ref="documenteditor" :enableEditor='true' :enableSearch='true' :enableOptionsPane='true'
      :isReadOnly='false' height="370px" style="width: 100%;"></ejs-documenteditor>
  </div>
</template>
<script>
import { DocumentEditorComponent, Selection, Editor, Search, OptionsPane } from '@syncfusion/ej2-vue-documenteditor';

export default {
  components: {
    'ejs-documenteditor': DocumentEditorComponent
  },
  data: function () {
    return {
    };
  },
  provide: {
    //Inject require modules.
    DocumentEditor: [Selection, Editor, Search, OptionsPane]
  },
  methods: {
    showOptionsPane: function () {
      //Open options pane.
      this.$refs.documenteditor.showOptionsPane();
    }
  },
  mounted() {
    let sfdt = `{
              "sections": [
                  {
                      "blocks": [
                          {
                              "inlines": [
                                  {
                                      "characterFormat": {
                                          "bold": true,
                                          "italic": true
                                      },
                                      "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                  }
                              ]
                          }
                      ]
                  }
              ]
          }`;
    this.$refs.documenteditor.open(sfdt);
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>

You can close the options pane by pressing Esc key.

The Search module of Document Editor exposes the following APIs:

API Name Type Description
findAll() Method Searches for specified text in the whole document and highlights it with yellow.
searchResults Property This is an instance of SearchResults.
find() Method Find immediate occurrence of specified text from cursor position in the document and highlights it with yellow.

Find the immediate occurrence in the document

Using find() method, you can find the immediate occurrence of specified text from current cursor position in the document.

The following example code illustrates how to use find in Document editor.

this.$refs.documenteditor.ej2instances.search.find('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Find all the occurrences in the document

Using findAll() method, you can find all the occurrences of specified text in the whole document and highlight it with yellow.

The following example code illustrates how to find All the text in the document.

this.$refs.documenteditor.ej2instances.search.findAll('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Search results

The SearchResults class provides information about the search results after a search operation is completed that can be identified using the searchResultsChange event. This will expose the following APIs:

API Name Type Description
length Property Returns the total number of results found on the search.
index Property Returns the index of selected search result. You can change the value for this property to move the selection.
replaceAll() Method Replaces all the occurrences with specified text.
clear() Method Clears the search result.

Replace all the occurrences

Using replaceAll, you can replace all the occurrences with specified text.

The following example code illustrates how to use replace All in Document editor.

this.$refs.documentEditor.ej2Instances.search.findAll ('Some text');
// Replace all the searched text with word 'Mike'
this.$refs.documentEditor.ej2Instances.search.searchResults.replaceAll("Mike");

Replace

Using insertText, you can replace the current searched text with specified text and it replace single occurrence.

Note: This insertText API accepts following control characters

  • New line characters (“\r”, “\r\n”, “\n”) - Inserts a new paragraph and appends the remaining text to the new paragraph.
  • Line break character (“\v”) - Moves the remaining text to start in new line.
  • Tab character (“\t”) - Allocates a tab space and continue the next character.

The following example code illustrates how to find a text in the document and replace each occurrence of the text one by one programmatically.

this.$refs.container.ej2instances.documentEditor.search.findAll('works');

let searchLength: number = container.documentEditor.search.searchResults.length;

for (let i = searchLength - 1; i >= 0; i--) {
  // It will move selection to specific searched index,move to each occurrence one by one
  this.$refs.container.ej2instances.documentEditor.search.searchResults.index = i;
  // Replace it with some text
  this.$refs.container.ej2instances.documentEditor.editor.insertText('Hello');
}

this.$refs.container.ej2Instances.documentEditor.search.searchResults.clear();

SearchResultsChange event

DocumentEditor exposes the searchResultsChangeevent that will be triggered whenever search results are changed. Consider the following scenarios:

  • A search operation is completed with some results.
  • The results are replaced with some other text, since it will be cleared automatically.
  • The results are cleared explicitly.

Refer to the following code example.

documenteditor.searchResultsChange = function() {

};

Customize find and replace

Using the exposed APIs, you can customize the find and replace functionality in your application. Refer to the following sample code.

<template>
    <div id="app" height="350px">
        <div>
            <table>
                <tr>
                    <td>
                        <label>Text to find:</label>
                    </td>
                    <td>
                        <input type="text" id="find_text" />
                    </td>
                </tr>
                <tr>
                    <td>
                        <label>Text to replace:</label>
                    </td>
                    <td>
                        <input type="text" id="replace_text" />
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <button id="replace_all" v-on:click='onReplaceButtonClick' style="float:right;margin-top: 10px;"
                            class="e-control e-btn">Replace All</button>
                    </td>
                </tr>
            </table>
        </div>
        <ejs-documenteditor ref="documenteditor" :enableEditor='true' :enableSearch='true' :enableOptionsPane='true'
            :isReadOnly='false' height="370px" style="width: 100%;"></ejs-documenteditor>
    </div>
</template>
<script setup>
import { provide, onMounted, ref } from "vue";
import { DocumentEditorComponent as EjsDocumenteditor, Selection, Editor, Search, OptionsPane } from '@syncfusion/ej2-vue-documenteditor';

const documenteditor = ref(null);
provide('DocumentEditor', [Selection, Editor, Search, OptionsPane]);

const onReplaceButtonClick = function () {
    let textToFind = (document.getElementById('find_text')).value;
    let textToReplace = (document.getElementById('replace_text')).value;
    if (textToFind !== '') {
        // Find all the occurences of given text
        documenteditor.value.ej2Instances.search.findAll(textToFind);
        if (documenteditor.value.ej2Instances.searchModule.searchResults.length > 0) {
            // Replace all the occurences of given text
            documenteditor.value.ej2Instances.search.searchResults.replaceAll(textToReplace);
        }
    }
}
onMounted(() => {
    let sfdt = `{
                    "sections": [
                        {
                            "blocks": [
                                {
                                    "inlines": [
                                        {
                                            "characterFormat": {
                                                "bold": true,
                                                "italic": true
                                            },
                                            "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }`;
    //Open the default document in Document Editor
    documenteditor.value.open(sfdt);
})
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>
<template>
    <div id="app" height="350px">
        <div>
            <table>
                <tr>
                    <td>
                        <label>Text to find:</label>
                    </td>
                    <td>
                        <input type="text" id="find_text" />
                    </td>
                </tr>
                <tr>
                    <td>
                        <label>Text to replace:</label>
                    </td>
                    <td>
                        <input type="text" id="replace_text" />
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <button id="replace_all" v-on:click='onReplaceButtonClick' style="float:right;margin-top: 10px;"
                            class="e-control e-btn">Replace All</button>
                    </td>
                </tr>
            </table>
        </div>
        <ejs-documenteditor ref="documenteditor" :enableEditor='true' :enableSearch='true' :enableOptionsPane='true'
            :isReadOnly='false' height="370px" style="width: 100%;"></ejs-documenteditor>
    </div>
</template>
<script>
import { DocumentEditorComponent, Selection, Editor, Search, OptionsPane } from '@syncfusion/ej2-vue-documenteditor';

export default {
    name: "App",
    components: {
        "ejs-documenteditor": DocumentEditorComponent
    },
    data: function () {
        return {
        };
    },
    provide: {
        //Inject require modules.
        DocumentEditor: [Selection, Editor, Search, OptionsPane]
    },
    methods: {
        onReplaceButtonClick: function () {
            let textToFind = (document.getElementById('find_text')).value;
            let textToReplace = (document.getElementById('replace_text')).value;
            if (textToFind !== '') {
                // Find all the occurences of given text
                this.$refs.documenteditor.ej2Instances.search.findAll(textToFind);
                if (this.$refs.documenteditor.ej2Instances.searchModule.searchResults.length > 0) {
                    // Replace all the occurences of given text
                    this.$refs.documenteditor.ej2Instances.search.searchResults.replaceAll(textToReplace);
                }
            }
        }
    },
    mounted() {
        let sfdt = `{
                    "sections": [
                        {
                            "blocks": [
                                {
                                    "inlines": [
                                        {
                                            "characterFormat": {
                                                "bold": true,
                                                "italic": true
                                            },
                                            "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }`;
        //Open the default document in Document Editor
        this.$refs.documenteditor.open(sfdt);
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>

Find and replace in Angular Document editor component

31 Dec 202420 minutes to read

The document editor component searches a portion of text in the document through a built-in interface called OptionsPane or rich APIs. When used in combination with selection performs various operations on the search results like replacing it with some other text, highlighting it, making it bolder, and more.

Options pane

This provides the options to search for a portion of text in the document. After search operation is completed, the search results will be displayed in a list and options to navigate between them. The current occurrence of matched text or all occurrences with another text can be replaced by switching to Replace tab. This pane is opened using the keyboard shortcut CTRL+F. You can also open it programmatically using the following sample code.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { DocumentEditorAllModule } from '@syncfusion/ej2-angular-documenteditor'
import { ToolbarModule } from '@syncfusion/ej2-angular-navigations'
import { ComboBoxModule } from '@syncfusion/ej2-angular-dropdowns'
import {ColorPickerModule } from '@syncfusion/ej2-angular-inputs'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
    DocumentEditorComponent, SelectionService, EditorService, SearchService, OptionsPaneService
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
imports: [
        
        ButtonModule,
        ToolbarModule,
        DocumentEditorAllModule,
        ComboBoxModule,
        ColorPickerModule
    ],


standalone: true,
      selector: 'app-container',
      //specifies the template string for the Document Editor component
      template: `<div>
      <button ejs-button (click)="showOptionsPane()" >Show</button>
      <ejs-documenteditor #document_editor height="330px" style="display:block" id="container" height="330px" style="display:block" [enableSelection]=true [enableSearch]=true [enableEditor]=true [isReadOnly]=false [enableOptionsPane]=true (created)="onCreated()"></ejs-documenteditor>
      </div>`,
      encapsulation: ViewEncapsulation.None,
      providers: [SelectionService, EditorService, SearchService, OptionsPaneService]
})

export class AppComponent {
    @ViewChild('document_editor')
    public documentEditor?: DocumentEditorComponent;

    onCreated(): void {
        if ((this.documentEditor as DocumentEditorComponent).isDocumentLoaded) {
            let sfdt: string = `{
                "sections": [
                    {
                        "blocks": [
                            {
                                "inlines": [
                                    {
                                        "characterFormat": {
                                            "bold": true,
                                            "italic": true
                                        },
                                        "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                    }
                                ]
                            }
                        ]
                    }
                ]
            }`;
            //Open the document in Document Editor
            (this.documentEditor as DocumentEditorComponent).open(sfdt);
        }
    }

    public showOptionsPane(): void {
        //Open options pane.
        (this.documentEditor as DocumentEditorComponent).showOptionsPane();
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can close the options pane by pressing Esc key.

The Search module of Document Editor exposes the following APIs:

API Name Type Description
findAll() Method Searches for specified text in the whole document and highlights it with yellow.
searchResults Property This is an instance of SearchResults.
find() Method Find immediate occurrence of specified text from cursor position in the document and highlights it with yellow.

Find the immediate occurrence in the document

Using find() method, you can find the immediate occurrence of specified text from current cursor position in the document.

The following example code illustrates how to use find in Document editor.

this.documenteditor.search.find('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Find all the occurrences in the document

Using findAll() method, you can find all the occurrences of specified text in the whole document and highlight it with yellow.

The following example code illustrates how to find All the text in the document.

this.documenteditor.search.findAll('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Search results

The SearchResults class provides information about the search results after a search operation is completed that can be identified using the searchResultsChange event. This will expose the following APIs:

API Name Type Description
length Property Returns the total number of results found on the search.
index Property Returns the index of selected search result. You can change the value for this property to move the selection.
replaceAll() Method Replaces all the occurrences with specified text.
clear() Method Clears the search result.

Replace all the occurrences

Using replaceAll, you can replace all the occurrences with specified text.

The following example code illustrates how to use replace All in Document editor.

this.documentEditor.search.findAll ('Some text');
// Replace all the searched text with word 'Mike'
this.documentEditor.search.searchResults.replaceAll("Mike");

Replace

Using insertText, you can replace the current searched text with specified text and it replace single occurrence.

Note: This insertText API accepts following control characters

  • New line characters (“\r”, “\r\n”, “\n”) - Inserts a new paragraph and appends the remaining text to the new paragraph.
  • Line break character (“\v”) - Moves the remaining text to start in new line.
  • Tab character (“\t”) - Allocates a tab space and continue the next character.

The following example code illustrates how to find a text in the document and replace each occurrence of the text one by one programmatically.

this.container.documentEditor.search.findAll('works');

let searchLength: number = this.container.documentEditor.search.searchResults.length;

for (let i = searchLength - 1; i >= 0; i--) {
  // It will move selection to specific searched index,move to each occurrence one by one
  this.container.documentEditor.search.searchResults.index = i;
  // Replace it with some text
  this.container.documentEditor.editor.insertText('Hello');
}

this.container.documentEditor.search.searchResults.clear();

SearchResultsChange event

DocumentEditor exposes the searchResultsChange event that will be triggered whenever search results are changed. Consider the following scenarios:

  • A search operation is completed with some results.
  • The results are replaced with some other text, since it will be cleared automatically.
  • The results are cleared explicitly.

Refer to the following code example.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
    DocumentEditorComponent, EditorService, SelectionService, SfdtExportService, EditorHistoryService, BookmarkDialogService
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
      selector: 'app-container',
      //specifies the template string for the Document Editor component
      template: `<ejs-documenteditor #document_editor  id="container" height="330px" style="display:block" [isReadOnly]=false [enableSelection]=true [enableSearch]=true (searchResultsChange)="onSearchResultChange()" > </ejs-documenteditor>`,
      encapsulation: ViewEncapsulation.None,
      providers: [EditorService, SelectionService, SfdtExportService]
})

export class AppComponent {
    @ViewChild('document_editor')
    public documentEditor: DocumentEditorComponent;

    // search result change event handler
    public onSearchResultChange(): void {

    }
}

Customize find and replace

Using the exposed APIs, you can customize the find and replace functionality in your application. Refer to the following sample code.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { DocumentEditorAllModule } from '@syncfusion/ej2-angular-documenteditor'
import { ToolbarModule } from '@syncfusion/ej2-angular-navigations'
import { ComboBoxModule } from '@syncfusion/ej2-angular-dropdowns'
import {ColorPickerModule } from '@syncfusion/ej2-angular-inputs'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
    DocumentEditorComponent, SelectionService, EditorService, SearchService, OptionsPaneService
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
imports: [
        
        ButtonModule,
        ToolbarModule,
        DocumentEditorAllModule,
        ComboBoxModule,
        ColorPickerModule
    ],


standalone: true,
      selector: 'app-container',
      //specifies the template string for the Document Editor component
      template: `<div style="width:100%;">
      <table>
          <tr>
              <td>
                  <label>Text to find:</label>
              </td>
              <td>
                  <input type="text" id="find_text" />
              </td>
          </tr>
          <tr>
              <td>
                  <label>Text to replace:</label>
              </td>
              <td>
                  <input type="text" id="replace_text" />
              </td>
          </tr>
          <tr>
              <td colspan="2">
                  <button ejs-button (click)="onReplaceButtonClick()" >Replace all</button>
              </td>
          </tr>
      </table>
      <ejs-documenteditor #document_editor id="container" height="330px" style="display:block" [enableSelection]=true [enableSearch]=true [enableEditor]=true [isReadOnly]=false (created)="onCreated()"></ejs-documenteditor>
      </div>`,
      encapsulation: ViewEncapsulation.None,
      providers: [SelectionService, EditorService, SearchService]
})

export class AppComponent {
    @ViewChild('document_editor')
    public documentEditor?: DocumentEditorComponent;

    onCreated(): void {
        if ((this.documentEditor as DocumentEditorComponent).isDocumentLoaded) {
            let sfdt: string = `{
            "sections": [
                {
                    "blocks": [
                        {
                            "inlines": [
                                {
                                    "characterFormat": {
                                        "bold": true,
                                        "italic": true
                                    },
                                    "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                }
                            ]
                        }
                    ]
                }
            ]
        }`;
            (this.documentEditor as DocumentEditorComponent).open(sfdt);
        }
    }

    public onReplaceButtonClick(): void {
        let textToFind: string = (document.getElementById('find_text') as HTMLInputElement).value;
        let textToReplace: string = (document.getElementById('replace_text') as HTMLInputElement).value;
        if (textToFind !== '') {
            // Find all the occurences of given text
            (this.documentEditor as DocumentEditorComponent).searchModule.findAll(textToFind);
            if ((this.documentEditor as DocumentEditorComponent).searchModule.searchResults.length > 0) {
                // Replace all the occurences of given text
                (this.documentEditor as DocumentEditorComponent).searchModule.searchResults.replaceAll(textToReplace);
            }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Find and replace in React Document editor component

31 Dec 202414 minutes to read

The document editor component searches a portion of text in the document through a built-in interface called OptionsPane or rich APIs. When used in combination with selection performs various operations on the search results like replacing it with some other text, highlighting it, making it bolder, and more.

Options pane

This provides the options to search for a portion of text in the document. After search operation is completed, the search results will be displayed in a list and options to navigate between them. The current occurrence of matched text or all occurrences with another text can be replaced by switching to Replace tab. This pane is opened using the keyboard shortcut CTRL+F. You can also open it programmatically using the following sample code.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { DocumentEditorComponent, SfdtExport, Selection, Editor, BordersAndShadingDialog } from '@syncfusion/ej2-react-documenteditor';

//Inject require module.
DocumentEditorComponent.Inject(SfdtExport, Selection, Editor, BordersAndShadingDialog);
function App() {
  let documenteditor: DocumentEditorComponent;
  React.useEffect(() => {
    ComponentDidMount()
  }, []);
  function ComponentDidMount() {
    let sfdt: string = `{
            "sections": [
                {
                    "blocks": [
                        {
                            "inlines": [
                                {
                                    "characterFormat": {
                                        "bold": true,
                                        "italic": true
                                    },
                                    "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                }
                            ]
                        }
                    ]
                }
            ]
        }`;
    //Open the document in Document Editor.
    documenteditor.open(sfdt);
  }

  function ShowHideOptionsPane() {
    //Open options pane.
    documenteditor.showOptionsPane();
  }
  return (
    <div>
      <button onClick={ShowHideOptionsPane}>OptionsPane</button>
      <DocumentEditorComponent id="container" height={'330px'} ref={(scope) => { documenteditor = scope; }} isReadOnly={false} enableSelection={true} enableEditor={true} enableSearch={true} enableOptionsPane={true} />
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('sample'));

You can close the options pane by pressing Esc key.

The Search module of Document Editor exposes the following APIs:

API Name Type Description
findAll() Method Searches for specified text in the whole document and highlights it with yellow.
searchResults Property This is an instance of SearchResults.
find() Method Find immediate occurrence of specified text from cursor position in the document and highlights it with yellow.

Find the immediate occurrence in the document

Using find() method, you can find the immediate occurrence of specified text from current cursor position in the document.

The following example code illustrates how to use find in Document editor.

this.documenteditor.search.find('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Find all the occurrences in the document

Using findAll() method, you can find all the occurrences of specified text in the whole document and highlight it with yellow.

The following example code illustrates how to find All the text in the document.

this.documenteditor.search.findAll('Some text', 'None');

Note: Second parameter is optional parameter and it denotes find Options. Possible values of find options are 'None' |'WholeWord' |'CaseSensitive'| 'CaseSensitiveWholeWord'.

Search results

The SearchResults class provides information about the search results after a search operation is completed that can be identified using the searchResultsChange event. This will expose the following APIs:

API Name Type Description
length Property Returns the total number of results found on the search.
index Property Returns the index of selected search result. You can change the value for this property to move the selection.
replaceAll() Method Replaces all the occurrences with specified text.
clear() Method Clears the search result.

Replace all the occurrences

Using replaceAll, you can replace all the occurrences with specified text.

The following example code illustrates how to use replace All in Document editor.

this.documentEditor.search.findAll ('Some text');
// Replace all the searched text with word 'Mike'
this.documentEditor.search.searchResults.replaceAll("Mike");

Replace

Using insertText, you can replace the current searched text with specified text and it replace single occurrence.

Note: This insertText API accepts following control characters

  • New line characters (“\r”, “\r\n”, “\n”) - Inserts a new paragraph and appends the remaining text to the new paragraph.
  • Line break character (“\v”) - Moves the remaining text to start in new line.
  • Tab character (“\t”) - Allocates a tab space and continue the next character.

The following example code illustrates how to find a text in the document and replace each occurrence of the text one by one programmatically.

this.container.documentEditor.search.findAll('works');

let searchLength: number = container.documentEditor.search.searchResults.length;

for (let i = searchLength - 1; i >= 0; i--) {
  // It will move selection to specific searched index,move to each occurrence one by one
  this.container.documentEditor.search.searchResults.index = i;
  // Replace it with some text
  this.container.documentEditor.editor.insertText('Hello');
}

container.documentEditor.search.searchResults.clear();

Customize find and replace

Using the exposed APIs, you can customize the find and replace functionality in your application. Refer to the following sample code.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { DocumentEditorComponent, SfdtExport, Selection, Editor, Search } from '@syncfusion/ej2-react-documenteditor';

//Inject require module.
DocumentEditorComponent.Inject(SfdtExport, Selection, Editor, Search);
function App() {
  let documenteditor: DocumentEditorComponent;
  React.useEffect(() => {
    ComponentDidMount()
  }, []);
  function ComponentDidMount() {
    let sfdt: string = `{
            "sections": [
                {
                    "blocks": [
                        {
                            "inlines": [
                                {
                                    "characterFormat": {
                                        "bold": true,
                                        "italic": true
                                    },
                                    "text": "Adventure Works Cycles, the fictitious company on which the AdventureWorks sample databases are based, is a large, multinational manufacturing company. The company manufactures and sells metal and composite bicycles to North American, European and Asian commercial markets. While its base operation is located in Bothell, Washington with 290 employees, several regional sales teams are located throughout their market base."
                                }
                            ]
                        }
                    ]
                }
            ]
        }`;
    //Open the document in Document Editor.
    documenteditor.open(sfdt);
  }

  function replaceAll() {
    let textToFind: string = (document.getElementById('find_text') as HTMLInputElement).value;
    let textToReplace: string = (document.getElementById('replace_text') as HTMLInputElement).value;
    if (textToFind !== '') {
      // Find all the occurences of given text
      documenteditor.searchModule.findAll(textToFind);
      if (documenteditor.searchModule.searchResults.length > 0) {
        // Replace all the occurences of given text
        documenteditor.searchModule.searchResults.replaceAll(textToReplace);
      }
    }
  }

  return (
    <div>
      <button onClick={replaceAll}>Replace All</button>
      <DocumentEditorComponent id="container" height={'590px'} ref={(scope) => { documenteditor = scope; }} isReadOnly={false} enableSelection={true} enableEditor={true} enableSearch={true} />
    </div>
  );

}
export default App
ReactDOM.render(<App />, document.getElementById('sample'));

See Also